Index: trunk/sources/HeuristicLab.Evolutionary/3.3/HeuristicLab.Evolutionary-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Evolutionary/3.3/HeuristicLab.Evolutionary-3.3.csproj	(revision 2818)
+++ trunk/sources/HeuristicLab.Evolutionary/3.3/HeuristicLab.Evolutionary-3.3.csproj	(revision 2830)
@@ -82,4 +82,5 @@
   <ItemGroup>
     <None Include="HeuristicLabEvolutionaryPlugin.cs.frame" />
+    <Compile Include="PopulationCreator.cs" />
     <Compile Include="HeuristicLabEvolutionaryPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: trunk/sources/HeuristicLab.Evolutionary/3.3/PopulationCreator.cs
===================================================================
--- trunk/sources/HeuristicLab.Evolutionary/3.3/PopulationCreator.cs	(revision 2830)
+++ trunk/sources/HeuristicLab.Evolutionary/3.3/PopulationCreator.cs	(revision 2830)
@@ -0,0 +1,80 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Evolutionary {
+  /// <summary>
+  /// An operator which creates a new population of solutions.
+  /// </summary>
+  [Item("PopulationCreator", "An operator which creates a new population of solutions.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public sealed class PopulationCreator : SingleSuccessorOperator {
+    public ValueLookupParameter<IntData> PopulationSizeParameter {
+      get { return (ValueLookupParameter<IntData>)Parameters["PopulationSize"]; }
+    }
+    public ValueLookupParameter<IOperator> SolutionCreatorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["SolutionCreator"]; }
+    }
+    public ValueLookupParameter<IOperator> SolutionEvaluatorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["SolutionEvaluator"]; }
+    }
+    private ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+    public IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+
+    public PopulationCreator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<IntData>("PopulationSize", "The number of individuals that should be created."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("SolutionCreator", "The operator which is used to create new solutions."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("SolutionEvaluator", "The operator which is used to evaluate new solutions."));
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope which represents the population."));
+    }
+
+    public override IExecutionSequence Apply() {
+      int size = PopulationSizeParameter.ActualValue.Value;
+      IOperator creator = SolutionCreatorParameter.ActualValue;
+      IOperator evaluator = SolutionEvaluatorParameter.ActualValue;
+
+      if (CurrentScope.SubScopes.Count > 0) throw new InvalidOperationException("Population is not empty. PopulationCreator cannot be applied on scopes which already contain sub-scopes.");
+
+      for (int i = 0; i < size; i++)
+        CurrentScope.SubScopes.Add(new Scope(i.ToString()));
+
+      ExecutionContextCollection next = new ExecutionContextCollection();
+      for (int i = 0; i < CurrentScope.SubScopes.Count; i++) {
+        if (creator != null) next.Add(ExecutionContext.CreateContext(creator, CurrentScope.SubScopes[i]));
+        if (evaluator != null) next.Add(ExecutionContext.CreateContext(evaluator, CurrentScope.SubScopes[i]));
+      }
+      next.Add(base.Apply());
+      return next;
+    }
+  }
+}
